/*
------------------------------
Onion Alternate Properties Rollout
David Humpherys
Blur Studios
daveh@blur.com
------------------------------
*/

Rollout OnionAltPropRoll "Onion Alternate Property"
(
	local layInd
	group "Properties"
	(
		checkbox UI_Userenderable align:#left
		checkbox UI_renderable "Renderable" width:84 height:16 align:#left offset:[30,-20] enabled:false
		checkbox UI_UseinheritVisibility  align:#left
		checkbox UI_inheritVisibility "Inherit Visibility"  width:93 height:16 align:#left offset:[30,-20] enabled:false
		checkbox UI_UseprimaryVisibility  align:#left
		checkbox UI_primaryVisibility "Visible to Camera"  width:105 height:16 align:#left offset:[30,-20] enabled:false
		checkbox UI_UsesecondaryVisibility align:#left
		checkbox UI_secondaryVisibility "Visible to Reflection/Refraction"  width:170 height:16 align:#left offset:[30,-20] enabled:false
		checkbox UI_UsereceiveShadows align:#left
		checkbox UI_receiveShadows "Receive Shadows"  width:123 height:16 align:#left offset:[30,-20] enabled:false
		checkbox UI_UsecastShadows align:#left
		checkbox UI_castShadows "Cast Shadows" width:123 height:16 align:#left offset:[30,-20] enabled:false
		checkbox UI_UseapplyAtmospherics align:#left
		checkbox UI_applyAtmospherics "Apply Atmospherics"  width:123 height:16 align:#left offset:[30,-20] enabled:false
		checkbox UI_UserenderOccluded align:#left
		checkbox UI_renderOccluded "Render Occluded Objects"width:153 height:16 align:#left offset:[30,-20] enabled:false
	)
	
	on UI_Userenderable changed state do UI_renderable.enabled = state
	on UI_UseinheritVisibility changed state do UI_inheritVisibility.enabled = state
	on UI_UseprimaryVisibility changed state do UI_primaryVisibility.enabled = state
	on UI_UsesecondaryVisibility changed state do UI_secondaryVisibility.enabled = state
	on UI_UsereceiveShadows changed state do UI_receiveShadows.enabled = state
	on UI_UsecastShadows changed state do UI_castShadows.enabled = state
	on UI_UseapplyAtmospherics changed state do UI_applyAtmospherics.enabled = state
	on UI_UserenderOccluded changed state do UI_renderOccluded.enabled = state
	
	
	on OnionAltPropRoll open do
	(
		layInd = finditem globaltracks.oniondata.layername globaltracks.oniondata.pickedlayer
		UseAltString = globaltracks.oniondata.UseAltProperty[ layInd ]
		AltString = globaltracks.oniondata.AltProperty[ layInd ]
		
		--check to see if it's in that mode
		if globaltracks.oniondata.isAltProperty[ layInd ] then messageBox "This layer is currently in Alternate Property Mode. \nThe changes you make here will not be made to the objects until you toggle Alt Properties on and off."

		val = if UseAltString[1] == "1" then true else false
		UI_Userenderable.checked =  val
		UI_renderable.enabled =  val
		val = if UseAltString[2] == "1" then true else false
		UI_UseinheritVisibility.checked = val
		UI_inheritVisibility.enabled = val
		val = if UseAltString[3] == "1" then true else false
		UI_UseprimaryVisibility.checked =  val
		UI_primaryVisibility.enabled =  val
		val = if UseAltString[4] == "1" then true else false
		UI_UsesecondaryVisibility.checked = val
		UI_secondaryVisibility.enabled = val
		val = if UseAltString[5] == "1" then true else false
		UI_UsereceiveShadows.checked = val
		UI_receiveShadows.enabled = val
		val = if UseAltString[6] == "1" then true else false
		UI_UsecastShadows.checked =  val
		UI_castShadows.enabled =  val
		val = if UseAltString[7] == "1" then true else false
		UI_UseapplyAtmospherics.checked =  val
		UI_applyAtmospherics.enabled =  val
		val = if UseAltString[8] == "1" then true else false
		UI_UserenderOccluded.checked = val
		UI_renderOccluded.enabled = val


		val = if AltString[1] == "1" then true else false
		UI_renderable.checked =  val
		val = if AltString[2] == "1" then true else false
		UI_inheritVisibility.checked = val
		val = if AltString[3] == "1" then true else false
		UI_primaryVisibility.checked =  val
		val = if AltString[4] == "1" then true else false
		UI_secondaryVisibility.checked = val
		val = if AltString[5] == "1" then true else false
		UI_receiveShadows.checked = val
		val = if AltString[6] == "1" then true else false
		UI_castShadows.checked =  val
		val = if AltString[7] == "1" then true else false
		UI_applyAtmospherics.checked =  val
		val = if AltString[8] == "1" then true else false
		UI_renderOccluded.checked = val
	)
	on OnionAltPropRoll close do
	(
		ObjString = "11111111"
		if UI_renderable.checked == false do ObjString[1] = "0"
		if UI_inheritVisibility.checked == false do ObjString[2] = "0"
		if UI_primaryVisibility.checked == false do ObjString[3] = "0"
		if UI_secondaryVisibility.checked == false do ObjString[4] = "0"
		if UI_receiveShadows.checked == false do ObjString[5] = "0"
		if UI_castShadows.checked == false do ObjString[6] = "0"
		if UI_applyAtmospherics.checked == false do ObjString[7] = "0"
		if UI_renderOccluded.checked == false do ObjString[8] = "0"		
		globaltracks.oniondata.AltProperty[ layInd ] = ObjString
		
		UseObjString = "11111111"
		if UI_Userenderable.checked == false do UseObjString[1] = "0"
		if UI_UseinheritVisibility.checked == false do UseObjString[2] = "0"
		if UI_UseprimaryVisibility.checked == false do UseObjString[3] = "0"
		if UI_UsesecondaryVisibility.checked == false do UseObjString[4] = "0"
		if UI_UsereceiveShadows.checked == false do UseObjString[5] = "0"
		if UI_UsecastShadows.checked == false do UseObjString[6] = "0"
		if UI_UseapplyAtmospherics.checked == false do UseObjString[7] = "0"
		if UI_UserenderOccluded.checked == false do UseObjString[8] = "0"		
		globaltracks.oniondata.UseAltProperty[ layInd ] = UseObjString	
	)
)
