/*
------------------------------
Onion Extended Menu
David Humpherys
Blur Studios
daveh@blur.com
------------------------------
*/

RCMenu OnionLayerMoreMenu
(
	menuItem miAddSelected "Add Selected to Layer"
	menuItem miSelect "Select Layer"
	menuItem miSelectObj "Select Objects on Layer" 
	Seperator sep01
	menuItem miDeleteLay "Delete Layer" 
	menuItem miDeleteBoth "Delete Layer and Objects" 
	seperator sep02
	menuItem miDefineAltMat "Pick Alternate Material"
	menuItem miDefineAltProp "Define Alternate Properties"
	seperator sep03
	menuItem miProp "Layer Properties"
	on miProp picked do (createdialog OnionLayerProperties 398 350 modal:true)
	
	on miAddSelected picked do ( 
		layInd = finditem globaltracks.oniondata.layername globaltracks.oniondata.pickedLayer
		if globaltracks.oniondata.isAltMaterial[ layInd ] or globaltracks.oniondata.isAltProperty[ layInd ] then
			messageBox "Cannot add the object to the layer.  The Layer is in an Alternate Mode. \nToggle the Layer out of Alternate mode to add objects"
		else Onion.addObjectsToLayer selection (globaltracks.oniondata.pickedLayer) 
	)

	on miSelect picked do
	(
		if (Onion.PREF_Debug_Mode)  then print ("RCMENU: miSelect picked")
		Onion.selectLayer ( layerManager.getLayerFromname globaltracks.oniondata.pickedLayer)
	)
	on miSelectObj picked do
	(
		if (Onion.PREF_Debug_Mode)  then print ("RCMENU: miSelectObj picked")
		fn SF obj  = (obj.layer.name == globaltracks.oniondata.pickedLayer )
		local MyAry= selectByName title:" Select Objects" buttonText:"Select" filter:SF 
		If MyAry != undefined then Select MyAry
	)
	on miDefineAltMat picked do
	(
		if (Onion.PREF_Debug_Mode)  then print ("RCMENU: miDefineAltMat picked")
		Onion.ui.showAltMatertial()
	)
	on miDefineAltProp picked do
	(
		if (Onion.PREF_Debug_Mode)  then print ("RCMENU: miDefineAltProp picked")
		Onion.ui.showAltProperties()
	)
	on miDeleteLay picked do
	(
		if (Onion.PREF_Debug_Mode)  then print ("RCMENU: miDeleteLay picked")
		local rootlayer = layerManager.getLayer 0
		local theLay = layerManager.getLayerFromName globaltracks.oniondata.pickedLayer
		--push all the items into the first layer
		local addobjs = for i in objects where i.layer.name == theLay.name collect i 
		Onion.addObjectsToLayer addobjs rootlayer.name
		--delete the layer
		Onion.deleteLayer theLay
	)
	on miDeleteBoth picked do
	(
		if (Onion.PREF_Debug_Mode)  then print ("RCMENU: miDeleteBoth picked")
		ans = querybox "Are you sure you want to delete the Objects and the Layer?"
		if ans then
		(
			local theLay = layerManager.getLayerFromName globaltracks.oniondata.pickedLayer
			--delete the objects
			local deletelist =#()
			for i in objects where i.layer.name == theLay.name do append deletelist i
			delete deletelist
			--delete the layer
			Onion.deleteLayer theLay
		)
	)
)
