/*
------------------------------
Onion Main Rollout
David Humpherys
Blur Studios
daveh@blur.com
------------------------------
*/

Rollout OnionRoll "theOnion"
(
	button CreateNewLayer height:26 width:44 pos:[2,5] ToolTip:"Create New Layer" images:#(OnionPath + "Onion_Buttons_I.bmp", OnionPath + "Onion_Buttons_M.bmp",4,1,1,1,1) 
	button CreateNewLayer_FromSel "" height:26 width:68 pos:[47,5] ToolTip:"Create New Layer From Selected Objects" images:#(OnionPath + "Onion_Buttons_I.bmp", OnionPath + "Onion_Buttons_M.bmp",4,2,2,2,2) 	
	button organize "O" height:26 width:48 pos:[115,5] ToolTip:"Organize Layers" images:#(OnionPath + "Onion_Buttons_I.bmp", OnionPath + "Onion_Buttons_M.bmp",4,3,3,3,3) 
	button OnionMore "" height:26 width:35 pos:[163,5] ToolTip:"Expanded Menu" images:#(OnionPath + "Onion_Buttons_I.bmp", OnionPath + "Onion_Buttons_M.bmp",4,4,4,4,4) 

	checkbutton worldActive "" width:23 height:17  highlightcolor:Onion.PREF_UI_ActiveLayerCheckColor pos:[2, 34] checked:((layermanager.getlayer 0).current) tooltip:"Make Current"
	checkbutton worldToggle "World Layer" width:155 height:17 align:#left pos:[26,34] checked:((layermanager.getlayer 0).on) tooltip:"Hide"
	checkbutton worldFreeze "" height:17 width:17 pos:[181,34] images:#(OnionPath + "Onion_Controls_I.bmp",OnionPath + "Onion_Controls_M.bmp", 10,1,5,1,5) tooltip:"Freeze" checked:((layermanager.getlayer 0).lock)
	
	progressbar pb pos:[4, 34]  width:191 height:10 color:([251,196,45] as color) --visible:false
		
	subrollout ui_param_area pos:[2,60] width:196 height:180
	
	on organize pressed do Onion.ui.showOrganize()

	on CreateNewLayer pressed do
	(
		--make a new one in the max system
		L = LayerManager.NewLayer()
		--add it to the First group--"main"
		Onion.addLayer L
		Onion.ui.refresh()

		--give option to name an place
		if Onion.PREF_PromptOnNew then Onion.ui.showOrganize()
	)
	on CreateNewLayer_FromSel pressed do
	(
		--make a new one in the max system
		L = LayerManager.NewLayer()
		--add it to the First group--"main"
		Onion.addLayer L
		Onion.ui.refresh()
		
		Onion.addObjectsToLayer selection  L.name
		
		if Onion.PREF_PromptOnNew then Onion.ui.showOrganize()
	)
	
	on worldActive changed state do ( 
		if state == true then ((layerManager.getlayer 0).current = state) 
		Onion.setActiveLayer 0
	)
	
	on worldToggle changed state do Onion.setHide 0 (not state)
	on worldFreeze  changed state do Onion.setFreeze 0 (state)
	
	on OnionMore pressed do PopupMenu OnionMoreMenu rollout:OnionRoll
	
	on OnionRoll moved loc do 
	( 
		globaltracks.oniondata.floaterposition = [ loc.x , loc.y , globaltracks.oniondata.floaterposition.z ]
	)
	on OnionRoll resized p2 do 
	(
		OnionRoll.width = 200
		ui_param_area.height = (p2.y - 75)
		globaltracks.oniondata.floaterposition = [ globaltracks.oniondata.floaterposition.x , globaltracks.oniondata.floaterposition.y , p2.y ]
		pb.pos.y = (globaltracks.oniondata.floaterposition.z - 12)
	)
	
	on OnionRoll open do 
	(
		ui_param_area.height = OnionRoll.height - 75
		pb.pos.y = OnionRoll.height - 12
	)
	on OnionRoll close do
	(
		for g = 1 to globaltracks.oniondata.groupname.count do try(globaltracks.oniondata.groupopen[g] = execute ("grp" + g as string + ".open")) catch()
	)

)