/*
------------------------------
Onion Layer Properties Rollout
David Humpherys
Blur Studios
daveh@blur.com
------------------------------
*/


Rollout OnionLayerProperties "Layer Properties"
(
	function changeProp prop val = 
	(
		if (Onion.PREF_Debug_Mode)  then print ("FN: changeProp prop: " + prop as string + " val: " + val as string )
		L = layermanager.getLayerFromName (globaltracks.oniondata.pickedlayer)
		setProperty L prop val
		if (isProperty objects[1] prop) then
		(
		--	createdialog OnionProgress
			disablesceneredraw()

			local theobjs = for i = 1 to objects.count where objects[i].layer.name == L.name collect objects[i]
			setProperty theobjs prop val
			/*
			case prop of 
			(

				default: ( setProperty theobjs prop val )
			)
			*/
			enablesceneredraw()
		--	destroydialog onionProgress
		)
	)
	groupBox grp1 "Layer Information" pos:[9,16] width:375 height:44 --76
	editText UI_LayerName "Name:" pos:[20,36] width:150 --text:L.name
	on UI_LayerName entered txt do 
	( 
		L = layermanager.getlayerFromName (globaltracks.oniondata.pickedlayer)
		L.setName txt
		
		--get the index from the name
		local Lind = finditem globaltracks.oniondata.layerName globaltracks.oniondata.pickedlayer
		local grp = Onion.getGroupFromLayer Lind
		
		--change the button text
		execute ("grp" +grp as string+ ".LToggle_" +Lind as string + ".text = \"" + txt + "\"") 
		
		--change the name 
		globaltracks.oniondata.layerName[ Lind ] = txt
		globaltracks.oniondata.pickedlayer = txt
	)


	colorPicker UI_WireColor "WireColor" pos:[180,36] width:80 height:15 --color:LM.Layers[ LM.PropChange ].wirecolor
	on UI_WireColor changed val do ( changeProp  #wirecolor  (val) )

	dropdownlist Ui_Display "" pos:[275, 32] width:100 items:#("Viewport", "Bounding box", "Wireframe", "Shaded")
	on UI_Display selected val do (changeProp #display (val-1) )

	groupBox grp3 "Rendering Control" pos:[9,67] width:192 height:168
	checkbox UI_renderable "Renderable" pos:[16,85] width:84 height:16 
	on UI_renderable changed state do ( changeProp  #renderable  state )
	spinner UI_Visibility "Visibility:" pos:[135,86] width:60 height:16 range:[0,1, 0]
	on UI_Visibility changed val do ( changeProp  #visibility val )
	checkbox UI_inheritVisibility "Inherit Visibility" pos:[16,103] width:93 height:16 
	on UI_inheritVisibility changed state do ( changeProp  #inheritVisibility state )
	checkbox UI_primaryVisibility "Visible to Camera" pos:[16,121] width:105 height:16 
	on UI_primaryVisibility changed state do ( changeProp  #primaryVisibility  state )
	checkbox UI_secondaryVisibility "Visible to Reflection/Refraction" pos:[16,139] width:170 height:16 
	on UI_secondaryVisibility changed state do (  changeProp  #secondaryVisibility state )
	checkbox UI_receiveShadows "Receive Shadows" pos:[16,157] width:123 height:16
	on UI_receiveShadows changed state do (  changeProp  #receiveShadows state )
	checkbox UI_castShadows "Cast Shadows" pos:[16,175] width:123 height:16 
	on UI_castShadows changed state do ( changeProp  #castShadows  state )
	checkbox UI_applyAtmospherics "Apply Atmospherics" pos:[16,193] width:123 height:16 
	on UI_applyAtmospherics changed state do (  changeProp   #applyAtmospherics  state )
	checkbox UI_renderOccluded "Render Occluded Objects" pos:[16,211] width:153 height:16
	on UI_renderOccluded changed state do ( changeProp  #renderOccluded state )
	
	groupBox grp4 "Display Properties" pos:[213,67] width:172 height:240
	checkbox UI_boxMode "Display as Box" pos:[220,85] width:118 height:16
	on UI_boxMode changed state do ( changeProp  #boxMode  state )
	checkbox UI_backFaceCull "Backface Cull" pos:[220,103] width:93 height:16
	on UI_backFaceCull changed state do ( changeProp  #backFaceCull state )
	checkbox UI_allEdges "Edges Only" pos:[220,121] width:105 height:16 
	on UI_allEdges changed state do ( changeProp  #alledges ( not state) )
	checkbox UI_vertexTicks "Vertex Ticks" pos:[220,139] width:138 height:16
	on UI_vertexTicks changed state do ( changeProp   #vertexTicks state )
	checkbox UI_showTrajectory "Trajectory" pos:[220,157] width:123 height:16 
	on UI_showTrajectory changed state do ( changeProp   #showTrajectory state )
	checkbox UI_xray "See-Through" pos:[220,175] width:123 height:16
	on UI_xray changed state do ( changeProp  #xray state )
	checkbox UI_ignoreExtents "Ignore Extents" pos:[220,193] width:123 height:16  
	on UI_ignoreExtents changed state do ( changeProp  #ignoreExtents  state )
	checkbox UI_showFrozenInGray "Show Frozen in Gray" pos:[220,211] width:153 height:16 
	on UI_showFrozenInGray changed state do ( changeProp  #showFrozenInGray  state )
	checkbox UI_showVertexColors "Vertex Color" pos:[220,229] width:80 height:16 
	on UI_showVertexColors changed state do ( changeProp   #showVertexColors  state )
	checkButton UI_vertexColorsShaded "Shaded" pos:[330,229] width:47 height:18 
	on UI_vertexColorsShaded changed state do ( changeProp  #vertexColorsShaded  state )
	
	groupBox UI_MBGrp "Motion Blur" pos:[8,243] width:192 height:63
	radioButtons UI_motionblur "" pos:[17,282] width:184 height:16 labels:#("None", "Object", "Image") columns:3 
	on UI_motionblur changed state do 
	( 
		case state of
		(
			1:( changeProp #motionblur  #none )
			2:( changeProp #motionblur  #object )
			3:( changeProp #motionblur  #image )
		)
	)
	checkbox UI_motionBlurOn "Enabled" pos:[16,261] width:100 height:16 
	on UI_motionBlurOn changed state do ( changeProp   #motionBlurOn  state )
	spinner UI_imageMotionBlurMultiplier "Multiplier" pos:[125,261] width:65 height:16 range:[0,1, 0 ]
	on UI_imageMotionBlurMultiplier changed val do ( changeProp   #imageMotionBlurMultiplier val )
	

	button UI_PropDone "Close" pos:[306,315] width:79 height:26
	button UI_PropHelp "Help" pos:[20,315] width:80 height:26
	on UI_PropDone pressed do destroyDialog OnionLayerProperties  	
	on UI_PropHelp pressed do messageBox "Toggle each of properties of the layer to change the property of the objects on the layer.\nOnly the properties you change will be effected."
	on OnionLayerProperties open do
	(
		if (Onion.PREF_Debug_Mode)  then print ("ROLLOUT OPEN: OnionLayerProperties " + globaltracks.oniondata.pickedlayer )
		L = layermanager.getlayerFromName (globaltracks.oniondata.pickedlayer)
		if L != undefined do
		(
			UI_Visibility.value = L.visibility
			case L.display of
			(
				#viewport: UI_Display.selection = 1
				#boundingbox: UI_Display.selection = 2
				#wireframe: UI_Display.selection = 3
				#shaded: UI_Display.selection = 4
			)

			UI_LayerName.text = L.name
			UI_WireColor.color = L.wirecolor
			UI_renderable.checked = L.renderable 
			UI_inheritVisibility.checked  = L.inheritvisibility 
			UI_primaryVisibility.checked = L.primaryvisibility
			UI_secondaryVisibility.checked = L.secondaryvisibility 
			UI_receiveShadows.checked = L.receiveshadows
			UI_castShadows.checked = L.castshadows
			UI_applyAtmospherics.checked  = L.applyatmospherics 
			UI_renderOccluded.checked = L.renderoccluded
			
			UI_boxMode.checked = L.boxMode
			UI_backFaceCull.checked = L.backfacecull 
			UI_allEdges.checked = L.allEdges
			UI_vertexTicks.checked = L.vertexticks 
			UI_showTrajectory.checked = L.showtrajectory
			UI_xray.checked = L.xray
			UI_ignoreExtents.checked = L.ignoreExtents
			UI_showFrozenInGray.checked = L.showfrozeningray 
			UI_showVertexColors.checked = L.showvertexcolors 
			UI_vertexColorsShaded.checked = L.vertexcolorsshaded
			
			case L.motionblur of
			(
				#none: UI_motionblur.state = 1
				#object: UI_motionblur.state = 2
				#image: UI_motionblur.state = 3
			)
			UI_motionBlurOn.checked = L.motionbluron
			UI_imageMotionBlurMultiplier.value = L.imagemotionblurmultiplier 
		)
		--else destroydialog OnionLayerProperties
	)
)
