/*
------------------------------
Onion Structure Definition
David Humpherys
Blur Studios
daveh@blur.com
------------------------------
*/

(
	--Define the RolloutCreatorClass..  it's loaded after this, and i can't determine the paths directory until after max launch..
	global rolloutCreator

	--Define the Stuct Member Globally so that i can use it 
	Global Onion
	Global OnionPath = (getdir #scripts)+"\\_blurScripts\\Onion\\"
	
	--Rollout Definitions
	global OnionRoll
	global OnionOrganize
	global OnionMoreMenu
	global OnionAbout
	global OnionLayerProperties 
	global OnionLayerMoreMenu
	global OnionPrefRoll 
	global OnionAltPropRoll
	global OnionAltMatRoll 


	Struct OnionUiStruct
	(
		--ui functions
		function resetDialogPosition =
		(
			if (Onion.PREF_Debug_Mode)  then print "FN: ui.resetDialogPosition()"
			globaltracks.oniondata.floaterposition = [300,300,300]
		),
		function refresh =
		(
			if (Onion.PREF_Debug_Mode)  then print ("FN: ui.refresh" )
			if onionRoll != undefined do
			(
				if onionRoll.open then
				(
					destroyDialog OnionRoll
					Onion.ui.showMain()
				)
			)
		),
		function showMain =
		(
			function createGroupRoll groupIndex =
			(
				--5672
				--5609
				--5391  --tweaked rollout creator
			--	timea = timestamp()
				if bitI == undefined then
				(
					global bitI = openbitmap (OnionPath + "Onion_Controls_I.bmp")
					global bitM = openbitmap (OnionPath + "Onion_Controls_M.bmp")
				)
				
				if (Onion.PREF_Debug_Mode)  then print ("FN: ui.createGroupRoll " + groupIndex as string )
				local LayersInGroup = Onion.getLayersInGroup GroupIndex 	--get a list of layer indexs that the group contain
				if (Onion.PREF_Debug_Mode)  then print ("\t LayersInGroup = " + LayersInGroup as string )
				rcRoll = rolloutCreator ( "grp"+groupIndex as string ) ( globaltracks.oniondata.GroupName[ groupIndex ] )
				rcRoll.begin()
				Ypos = 5
				
				local LayerIndArray  = Onion.getLayerOrder LayersInGroup
				
				for L in LayerIndArray do
				(
					LayRef = Onion.GetLayerReference L
					if LayRef != undefined then
					(
						local buttonNumber = ("_"+ L as string)
						YPosS = Ypos as string
						
						local LayActString = (" width:10 height:17 highlightcolor:"+Onion.PREF_UI_ActiveLayerCheckColor as string + " pos:[ 2 ,"+ YPosS+"] checked:" + LayRef.current as string + " tooltip:\"Set as current layer\"" )
						rcRoll.addControl #checkbutton (("LayAct"+buttonNumber)as name) "" paramStr:LayActString
						rcRoll.addHandler (("LayAct"+buttonNumber)as name) #changed paramStr:"state" codestr:("Onion.SetActiveLayer " + L as string + " active:state")
				
						--Layer Toggle Checkbutton		
						local LToggleString = (" highlightcolor:"+Onion.PREF_UI_HideCheckColor as string +" width:111 height:17 align:#left pos:[ 13 ,"+ YPosS+"]  tooltip:\"Toggle Layer On/Off     Shift-Click to effect whole group\" checked:"+ LayRef.on as string )
						rcRoll.addControl #checkbutton (("LToggle"+buttonNumber)as name) (LayRef.name) paramStr:LToggleString --Layers[L].lmRef.Name --
						rcRoll.addHandler (("LToggle"+buttonNumber) as name) #changed paramStr:"state" codestr:("Onion.sethide " + L as string + " " + "(not state) " )
					
						--Layer Freeze Checkbutton
						local Lay_FreezeString = (" height:17 width:15 pos:[125,"+YPosS+"] images:#(bitI ,bitM, 10,1,5,1,5)  checked:" + LayRef.lock as string + " tooltip:\"Freeze Layer\" ")
						rcRoll.addControl #checkbutton (("Lay_Freeze"+buttonNumber)as name) "" paramStr:Lay_FreezeString
						rcRoll.addHandler (("Lay_Freeze"+buttonNumber )as name) #changed paramStr:"state" codestr:("Onion.setFreeze " + L as string + " state" )
				
						--Layer Alt Material Checkbutton
						local Lay_MatteString = (" height:17 width:15 pos:[140,"+YPosS+ "]   images:#(bitI ,bitM , 10,2,6,2,6) tooltip:\"Alternate Material\" checked:(globaltracks.oniondata.isAltMaterial[" + L as string + "] )")	
						rcRoll.addControl #checkbutton (("Lay_Matte"+buttonNumber )as name) "" paramStr:Lay_MatteString
						rcRoll.addHandler (("Lay_Matte"+buttonNumber )as name) #changed paramStr:"state" codestr:("globaltracks.oniondata.pickedLayer =  globaltracks.oniondata.layerName[" + L as string +" ]
							Onion.setAltMat "+ L as string +" state " + GroupIndex as string  )
	
						--Layer Alt Prop Checkbutton
						local Lay_PropString = (" height:17 width:15 pos:[155,"+YPosS+ "]   checked:(globaltracks.oniondata.isAltProperty[" + L as string + "] ) images:#(bitI ,bitM , 10,3,7,3,7) tooltip:\"Alternate Property\" ")	
						rcRoll.addControl #checkbutton (("Lay_Prop"+buttonNumber )as name) "" paramStr:Lay_PropString
						rcRoll.addHandler (("Lay_Prop"+buttonNumber )as name) #changed paramStr:"state" codestr:("globaltracks.oniondata.pickedLayer =  globaltracks.oniondata.layerName[" + L as string +" ]
							Onion.setAltProp "+ L as string +" state " + GroupIndex as string  )
			
						--Layer Expanded Menu
						LConString = (" width:9 height:17 pos:[171," + YPosS+ "] images:#(bitI ,bitM, 10,4,4,4,4)  tooltip:\"Extended Menu      Shift-Click to Select Layer    Ctrl-Shift-Click to Select Group\"  ")
						rcRoll.addControl #button (("LCon"+buttonNumber)as name) ">" paramStr:LConString
						local expandedMenuString = ("globaltracks.oniondata.pickedLayer =  globaltracks.oniondata.layerName[" + L as string +" ] 
							if keyboard.shiftPressed == true then (
								DisableSceneRedraw()
								Onion.selectLayer (Onion.GetLayerReference " + L as string + ") more:true
								EnableSceneRedraw()
							)
							else(
								Popupmenu OnionLayerMoreMenu 
							)" 
						)
				
						rcRoll.addHandler (("LCon"+buttonNumber)as name) #pressed codeStr:expandedMenuString 
					--	gc()
						Ypos += 22
					)
					else if (Onion.PREF_Debug_Mode)  then print ("ERROR: createGroupRoll couldn't get a layer reference to groupIndex: " + GroupIndex as string )
				)
				gc()
				rcRoll.end()
--				close bitI
--				close bitM
			--	timeb = timestamp()
			--	print "done"
			--	print (timeb-timea)
				return rcRoll.def
			
			
			)
			function createXRefGroup =
			(
				if (Onion.PREF_Debug_Mode)  then print "FN: ui.createXRefGroup()"
				rci= rolloutCreator "XRScene" "XRef Scenes"
				rci.begin()
				Ypos = 5
				
				for XR = 1 to xrefs.getXRefFileCount() do
				(
					local XRfile = xrefs.getxreffile XR
					local XRfileName = filenamefromPath (XRfile.filename)
					local XRfileHid = XRFile.hidden
					local XRfileEnab = not (XRFile.disabled)
	
					rci.addControl #checkbox (("XRENab"+ XR as string) as name) "" paramStr:("pos:[2," + Ypos as string + "] width:15 checked:"+ XRfileEnab as string +" \n" )					
					local XRVisString = ("highlightcolor:" + Onion.PREF_UI_XRefCheckColor as string + " checked:"+ (NOT XRfile.hidden) as string + " width:150  height:17  align:#left pos:[20,
							"+Ypos as string+"]   checked:"+XRfileHid as string + " tooltip:\"Toggle XRef Visibility\"\n" )
					rci.addControl #checkbutton (("XRVis"+ XR as string) as name) XRfileName paramStr:XRVisString
					
					rci.addHandler (("XRENab"+ XR as string) as name) #changed paramStr:"state" codestr:("
						Temp = xrefs.getxreffile " + XR as string + "
						Temp.hidden = (not state)")
					rci.addHandler (("XRVis"+ XR as string) as name) #changed paramStr:"state" codestr:("
						Temp = xrefs.getxreffile " + XR as string + "
						Temp.disabled = (not state)")
					Ypos+=20
				)
				rci.end()
				return rci.def
			)	
			
			if (Onion.PREF_Debug_Mode)  then print "FN: ui.showMain()"
			if OnionRoll.open == false then
			(
				local FP = globaltracks.OnionData.FloaterPosition
				
				--check the floater position for negative #'s or numbers outside the size of the screen
				if fp.x < 0 or fp.x > sysinfo.desktopsize.x then FP = [ 200, fp.y, fp.z]
				if fp.y < 0 or fp.y > (sysinfo.desktopsize.y-60) then FP = [ fp.x, 200, fp.z]				
				if fp.z == 0 then FP =  [ fp.x, fp.y, 300 ]				
				--set it back into globacl info
				globaltracks.OnionData.FloaterPosition = FP
				createdialog onionroll 200 FP.Z FP.x FP.y style:#(#style_titlebar, #style_sysmenu, #style_resizing, #style_minimizebox)
				for G = 1 to globaltracks.oniondata.GroupOrder.count do		--G == the index into all the other arrays
				(	
					grpInd = finditem globaltracks.oniondata.GroupOrder G
					--define a group rollout
					grpRoll = createGroupRoll grpInd  				
					--add it to the rollout
					addSubRollout OnionRoll.ui_param_area grpRoll rolledup:(not (globaltracks.oniondata.groupOpen[grpInd]))
				)
				if ( Onion.PREF_DisXRScene == true ) then
				(
					xrefRoll = createXRefGroup()
					addSubRollout OnionRoll.ui_param_area xrefRoll
				)
				
			)
		),
		function showPreferences = 
		( 
			if (Onion.PREF_Debug_Mode)  then print "FN: ui.showPreferences()"
			createDialog OnionPrefRoll 290 240 modal:true
		),
		function showOrganize =
		(
			if (Onion.PREF_Debug_Mode)  then print "FN: ui.showOrganize()"
			createdialog OnionOrganize 280 400  style:#(#style_titlebar, #style_sysmenu, #style_resizing) modal:true 
		),
		function showAbout = 
		( 
			if (Onion.PREF_Debug_Mode)  then print "FN: ui.showAbout()"
			createdialog OnionAbout 300 60 
		),
		function showProperties = 
		( 
			if (Onion.PREF_Debug_Mode)  then print "FN: ui.showProperties()"
			createdialog OnionLayerProperties 398 350 modal:true 
		),
		function showAltMatertial = 
		(  
			if (Onion.PREF_Debug_Mode)  then print "FN: ui.showAltMatertial()"
			createdialog OnionAltMatRoll 240 80 
		),
		function showAltProperties  = 
		( 
			if (Onion.PREF_Debug_Mode)  then print "FN: ui.showAltProperties()"
			createdialog OnionAltPropRoll 250 200 
		)
	)
	
	
	Struct OnionStruct
	(
	--	OnionData = undefined,
	--	OnionRoll = undefined,
		version = 1.14,
		ui = OnionUiStruct(),
		--Preferences members
		PREF_UI_ActiveLayerCheckColor = false,
		PREF_UI_HideCheckColor = false,
		PREF_UI_XRefCheckColor = false,
		PREF_DisXRScene= false,
		PREF_PromptOnNew = false,
		PREF_Inherit_Wire= false,
		PREF_Inherit_Display = false,
		PREF_Inherit_Render = false,
		PREF_Inherit_Blur = false,
		PREF_Debug_Mode = false,
		
		--data sorting & gathering functions
		function convertStringAry2IntAry sArray =
		(
		--	if (PREF_Debug_Mode)  then print ("FN: StringArrayAsIntArray SArray: " + SArray as string )
			local split = filterstring sArray ","
			local IntArray = #()
			for i in split do append IntArray (i as integer)
			return IntArray 
		),
		function getLayersInGroup groupInd =
		(
			if (PREF_Debug_Mode)  then print ("FN: getLayersInGroup " + groupInd as string )
			local grparray =#()
			for g = 1 to globaltracks.oniondata.LayerGroup.count where globaltracks.oniondata.LayerGroup[ g ] == groupInd do append grparray g 
			return grparray
		),
		function getGroupLayersFromlayer layerInd =
		(
			if (PREF_Debug_Mode)  then print ("FN: getGroupLayersFromLayer " + layerInd as string )
			local grpInd = globaltracks.oniondata.LayerGroup[ layerInd ]
			local grpArray = #()
			for g = 1 to globaltracks.oniondata.LayerGroup.count where globaltracks.oniondata.LayerGroup[ g ] == grpInd do append grpArray g
			return grpArray
		),
		function getGroupFromLayer layerInd =
		(
			if (PREF_Debug_Mode)  then print ("FN: getGroupFromLayer " + layerInd as string )
			return globaltracks.oniondata.LayerGroup[ layerInd ]
		),
		function getLayerOrder layerIndArray =
		(
			if (PREF_Debug_Mode)  then print ("FN: getLayerOrder LayerIndArray:" + layerIndArray as string )
			local matchArray = #()
			local orderedArray = #()
			--build an array that matches the input array
			for L in LayerIndArray do append matchArray globaltracks.oniondata.LayerIndex[ L ]
			--reorder the input array to the order of the match array
			for c = 1 to LayerIndArray.count do
			(
				ind = finditem matchArray c
				append orderedArray LayerIndArray[ ind ]
			)
			return orderedArray
		),
		function getLayerReference layerInd =
		(
			if (PREF_Debug_Mode)  then print ("FN: getLayerReference layerInd: " + layerInd as string )


			if layerInd == 0 then return (LayerManager.getlayer 0)
			else
			(
				lmref = layerManager.getLayerFromName globaltracks.oniondata.LayerName[ layerInd ]
				if lmref != undefined then return lmref
				else 
				(
					if (PREF_Debug_Mode)  then print ("\t couldn't get a reference to the layer: " + layerInd as string )
					return undefined
				)
			)
		),
		function getLayerObjects layerRef useGroup:false=
		(
			if (PREF_Debug_Mode)  then print ("FN: getLayerObjects lmRef: " + layerRef.name )
			local objArray = #()
			if useGroup == true then
			(
				--find the group
				layerInd = finditem globaltracks.oniondata.layername layerRef.name
				--get the layers in the group
				layAry = getGroupLayersFromLayer layerInd 
				--make an array of strings for each layer name in the lay ary
				LayNameArray = #()
				for L in layAry do append LayNameArray globaltracks.oniondata.layername[ L ]
				--get the objects that are on any of those layers
				for obj in objects where (finditem LayNameArray obj.layer.name) > 0 do  ( append objArray Obj )
			)
			else for obj in objects where obj.layer.name == layerRef.name do ( append objArray Obj )		
			return objArray
		),
		
		
		
		--core layer functions -------------------------------------------------------------------------------------------------------------------------------
		function selectLayer layerRef more:false=
		(
			if (PREF_Debug_Mode)  then print ("FN: selectLayer lmRef: " + layerRef.name + " more: "+more as string)
			setWaitCursor()
			DisableSceneRedraw()
			if more == false then max select none
			local selectAry
			if keyboard.controlpressed == true then selectAry = getLayerObjects layerRef useGroup:true
			else selectAry = getLayerObjects layerRef
			if more == false then select selectAry
			else selectmore selectAry
			EnableSceneRedraw()
			SetArrowCursor()
		),
		function hideLayer layerRef  =
		(
			if (PREF_Debug_Mode)  then print ("FN: HideLayer lmRef:" + layerRef.name )
			setWaitCursor()

			DisableSceneRedraw()
			layerRef.on = false
			count = 0
			objAry = #()

			for i in objects where i.layer.name ==  layerRef.name do 
			(	
				append objAry i
				count +=1
				--removed these 2 due to a strange bug kevin had with groups on his machine but not mine.
		--		i.ishidden = true 
		--		deselect i
				OnionRoll.pb.value = ( count / (objects.count as float) ) * 100
			)

			objAry.ishidden = true
			deselect objAry
			
			EnableSceneRedraw()
			SetArrowCursor()
			OnionRoll.pb.value = 0
		),
		function unhideLayer layerRef =
		(
			if (PREF_Debug_Mode)  then print ("FN: UnHideLayer layerRef :" + layerRef.name )
			setWaitCursor()
			DisableSceneRedraw()
			layerRef.on = true
			count = 0
			for i in objects where i.layer.name == layerRef.name do 
			(
				count +=1
				i.ishidden = false
				OnionRoll.pb.value = ( count / (objects.count as float) ) * 100
			)
			EnableSceneRedraw()
			SetArrowCursor()
			OnionRoll.pb.value = 0
		),
		function setHide layerInd state=
		(
			if (PREF_Debug_Mode)  then print ("FN: setHide layerInd :" + layerInd as string +" state: " + state as string)
			if keyboard.shiftpressed == true and layerInd != 0 then
			(
				local intArray = getGroupLayersFromLayer layerInd 
				if (PREF_Debug_Mode)  then print ("\tintArray: " + intArray as string)
				local grp = getGroupFromLayer layerInd 
				if (PREF_Debug_Mode)  then print ("\tgrp: " + grp as string)
				for L in intArray do
				(
					lmRef = GetLayerReference L
					if state == true then HideLayer lmRef
					else UnHideLayer lmRef
					execute ("grp" + grp as string +".LToggle_" + L as string + ".checked = " + (not state) as string)	
				)
			)
			else
			(
				--get the reference to the layer
				lmRef = GetLayerReference layerInd 
				if state == true then HideLayer lmRef
				else UnHideLayer lmRef
			)
		),
		function setFreeze layerInd state=
		(
			if (PREF_Debug_Mode)  then print ("FN: setFreeze layerInd :" + layerInd as string +" state: " + state as string)		
			if keyboard.shiftpressed == true then
			(
				local intArray = getGroupLayersFromLayer layerInd 
				if (PREF_Debug_Mode)  then print ("\tintArray: " + intArray as string)
				local grp = getGroupFromLayer layerInd 
				if (PREF_Debug_Mode)  then print ("\tgrp: " + grp as string)
				for L in intArray do
				(
					lmRef = GetLayerReference L
					setWaitCursor()	
					DisableSceneRedraw()
					if (state) then lmRef.lock = true 
					else lmRef.lock = false		
					for i in objects where i.layer.name == lmRef.name do i.isFrozen = state 
					EnableSceneRedraw()
					SetArrowCursor()
					execute ("grp" + grp as string +".Lay_Freeze_" + L as string + ".checked = " + state as string)
				)	
			)
			else
			(	
				lmRef = GetLayerReference layerInd 
				setWaitCursor()
				DisableSceneRedraw()
				if (state) then lmRef.lock = true 
				else lmRef.lock = false		
				for i in objects where i.layer.name == lmRef.name do i.isFrozen = state 
				EnableSceneRedraw()
				SetArrowCursor()
			)
		),
		function setAltMat layerInd state grp=
		(
			if (PREF_Debug_Mode)  then print ("FN: SetAltMat layerInd : " + layerInd as string+ " state: " + state as string )	
			lmRef = Onion.GetLayerReference layerInd 
			SetWaitCursor()
			disableSceneRedraw()	
			if state == true then
			(
				--check to see if the alternate material has been defined.
				if globaltracks.oniondata.altmaterial[ layerInd ] == undefined then 
				(
					messagebox "Set Alernate Material Aborted.  You must define the alternate material first." title:"theOnion Warning:"
					--now i need to uncheck the checked thingy
					try
					(	execute ( "grp" + grp as string + ".Lay_Matte_" + layerInd as string + ".checked = false"))
					catch()
					--open that dialog
					ui.showAltMatertial()
				)
				else
				(
					globaltracks.oniondata.isAltMaterial[ layerInd ] = true
					justcopied = #()
					--walk through all the objects on that layer
					for i = 1 to objects.count do
					(
						if objects[ i ].layer.name == lmref.name and \
							(superclassof objects[ i ] == Geometryclass or superclassof objects[ i ] == Shape) \
							and classof objects[ i ] != TargetObject do
						(
							--push the name of the material onto to appdata of the object
							if objects[ i ].material == undefined then setappdata objects[ i ] 1108 "undefined"
							else setappdata objects[ i ] 1108 objects[ i ].material.name
							--look for a material by the same name in the reference
							if objects[ i ].material != undefined do
							(
								--check to see if i've copied it already in this alt mat move
								if (finditem justcopied objects[i].material.name) == 0 then
								(
									local found = false
									for m = 1 to  globaltracks.oniondata.MaterialHolder.count do
									(
										if globaltracks.oniondata.MaterialHolder[m].name == objects[ i ].material.name do
										(
											 found = true
											 globaltracks.oniondata.MaterialHolder[m] =  (objects[ i ].material)
											 exit
										)
									)
									if found == false then
									(
										append globaltracks.oniondata.MaterialHolder (objects[ i ].material)
									)
									append justcopied objects[i].material.name
								)
							)
							--push the alternate material onto the object
							objects[ i ].material = globaltracks.oniondata.altmaterial[ layerInd ]
							
						)
						if OnionRoll != undefined then OnionRoll.pb.value = ( i / (objects.count as float) ) * 100
					)
				)
			)
			else  --unchecking alt material...restore the orig material
			(
				globaltracks.oniondata.isAltMaterial[ layerInd ] = false
				--ADD progresss code
				for i = 1 to objects.count do
				(
					if objects[ i ].layer.name == lmref.name and \
						(superclassof objects[ i ] == Geometryclass or superclassof objects[ i ] == Shape) \
						and classof objects[ i ] != TargetObject do
					(
				
						local o = objects[ i ]
						if getappdata o 1108 == "undefined" then o.material = undefined
						else
						(
							---find the material
							altMatInd = 0
							for i = 1 to globaltracks.oniondata.MaterialHolder.count do
							(
								if globaltracks.oniondata.MaterialHolder[ i ].name == getappdata o 1108 then
								(
									altMatInd = i
									exit
								)
							)
							if altMatInd == 0 then messagebox "Something terribile has happened.  The material has been lost." title:"theOnion Warning:"
							else
							(
								--seach the scene for an object that has the same material on it..
								local found = 0
								for i in objects where i.material != undefined do
								(
									if i.material.name == globaltracks.oniondata.MaterialHolder[ altMatInd ].name do 
									(
										found = i
										exit
									)	
								)
								if found == 0 then o.material = globaltracks.oniondata.MaterialHolder[ altMatInd ]
								else o.material = found.material
							)
						)
						--remove the appdata
						deleteappdata o 1108
					)
					if OnionRoll != undefined then OnionRoll.pb.value = ( i / (objects.count as float) ) * 100
				)
				--check to see if any other layers are in alt mode, and if not, clear out the alternate material array
				if (finditem globaltracks.oniondata.isAltMaterial true) == 0 then
					globaltracks.oniondata.MaterialHolder = #()


			)	
			enableSceneRedraw()		
			--gc()
			SetArrowCursor()
			if OnionRoll != undefined then OnionRoll.pb.value = 0.0
		),
		function setAltProp layerInd state grp=
		(
			if (PREF_Debug_Mode)  then print ("FN: SetAltProp layerInd : " + layerInd as string+ " state: " + state as string )	
			lmRef = Onion.GetLayerReference layerInd 
			SetWaitCursor()
			disableSceneRedraw()	
			if state == true then
			(
				--check and see if any of the alt prop mebers are turned on
				if findstring globaltracks.oniondata.UseAltProperty[layerInd ] "1" == undefined then
				(
					messagebox "Set Alernate Property Aborted.  There are no alternate properties enabled." title:"theOnion Warning:"
					--use a try in case it's not open or defined.
					try (
					--now i need to uncheck the checked thingy
					execute ( "grp" + grp as string + ".Lay_Prop_" + layerInd as string + ".checked = false")
					)
					catch()
					--open that dialog
					ui.showAltProperties()
				)
				else
				(
					--set the objects in alternate property mode
					globaltracks.oniondata.isAltProperty[ layerInd ] = true
	
					local AltString = globaltracks.oniondata.AltProperty[ layerInd ]
					local UseAltString = globaltracks.oniondata.UseAltProperty[ layerInd ]
		
					--walk through all the objects on that layer and set the properties
					for i = 1 to objects.count do
					(
						if objects[ i ].layer.name == lmref.name do
						(			
							--set the properties on the object it self so that i can get them back
							ObjString = "11111111"
							if getProperty objects[i] #renderable == false do ObjString[1] = "0"
							if getProperty objects[i] #inheritVisibility == false do ObjString[2] = "0"
							if getProperty objects[i] #primaryVisibility  == false do ObjString[3] = "0"
							if getProperty objects[i] #secondaryVisibility == false do ObjString[4] = "0"
							if getProperty objects[i] #receiveShadows == false do ObjString[5] = "0"
							if getProperty objects[i] #castShadows  == false do ObjString[6] = "0"
							if getProperty objects[i] #applyAtmospherics  == false do ObjString[7] = "0"
							if getProperty objects[i] #renderOccluded == false do ObjString[8] = "0"		
							setappdata objects[ i ] 1110 ObjString
							
							if UseAltString[1] == "1" then
							(
								val = if AltString[1] == "1" then true else false
								setProperty objects[i] #renderable val
							)
							if UseAltString[2] == "1" then
							(
								val = if AltString[2] == "1" then true else false
								setProperty objects[i] #inheritVisibility val
							)
							if UseAltString[3] == "1" then
							(
								val = if AltString[3] == "1" then true else false
								setProperty objects[i] #primaryVisibility  val
							)
							if UseAltString[4] == "1" then
							(
								val = if AltString[4] == "1" then true else false
								setProperty objects[i] #secondaryVisibility val
							)
							if UseAltString[5] == "1" then
							(
								val = if AltString[5] == "1" then true else false
								setProperty objects[i] #receiveShadows val
							)
							if UseAltString[6] == "1" then
							(
								val = if AltString[6] == "1" then true else false
								setProperty objects[i] #castShadows  val
							)
							if UseAltString[7] == "1" then
							(
								val = if AltString[7] == "1" then true else false
								setProperty objects[i] #applyAtmospherics  val
							)
							if UseAltString[8] == "1" then
							(
								val = if AltString[8] == "1" then true else false
								setProperty objects[i] #renderOccluded val
							)
						)
						if OnionRoll != undefined then OnionRoll.pb.value = ( i / (objects.count as float) ) * 100
					)
				)
			)
			else
			(
				--return the objects out of alt propert mode
				globaltracks.oniondata.isAltProperty[ layerInd ] = false

				--walk through all the objects on that layer and set the properties
				for i = 1 to objects.count do
				(
					if objects[ i ].layer.name == lmref.name do
					(			
						AltString = getAppdata objects[i] 1110
						if AltString != undefined then
						(
							val = if AltString[1] == "1" then true else false
							setProperty objects[i] #renderable val
							val = if AltString[2] == "1" then true else false
							setProperty objects[i] #inheritVisibility val
							val = if AltString[3] == "1" then true else false
							setProperty objects[i] #primaryVisibility  val
							val = if AltString[4] == "1" then true else false
							setProperty objects[i] #secondaryVisibility val
							val = if AltString[5] == "1" then true else false
							setProperty objects[i] #receiveShadows val
							val = if AltString[6] == "1" then true else false
							setProperty objects[i] #castShadows  val
							val = if AltString[7] == "1" then true else false
							setProperty objects[i] #applyAtmospherics  val
							val = if AltString[8] == "1" then true else false
							setProperty objects[i] #renderOccluded val
						)
					)
					if OnionRoll != undefined then OnionRoll.pb.value = ( i / (objects.count as float) ) * 100
				)				
			)
			enableSceneRedraw()		
			--gc()
			SetArrowCursor()
			if OnionRoll != undefined then OnionRoll.pb.value = 0.0	
		),
		function setActiveLayer layerInd active:true =
		(
			if (PREF_Debug_Mode)  then print ("FN: SetActiveLayer layerInd: " + layerInd as string )	
			if (active) then
			(
				lmref = GetLayerReference layerInd 
				lmref.current  = true
				OnionRoll.worldActive.checked = (layermanager.getlayer 0).current
				for G = 1 to globaltracks.oniondata.GroupName.count do
				(
					local LayerNameArray = getLayersInGroup G
					for L in LayerNameArray do
					(
						local cLay = getLayerReference L
						execute ( "grp" + G as string + ".LayAct_"  + L as string + ".checked = " + cLay.current as string )
					)
				)
			)
			else 
			(
				--turn on the 0 layer
				lmref = GetLayerReference 0
				lmref.current  = true
				OnionRoll.WorldActive.checked = true
			)
		),
		
		function addLayer lmRef=
		(
			if (PREF_Debug_Mode)  then print ("FN: addLayer " + lmRef.name)
			append globaltracks.oniondata.LayerName 	lmRef.name					--add the name to the array
			append globaltracks.oniondata.LayerGroup  1							--put it in the first group that HAS to exist
			
			if globaltracks.oniondata.LayerIndex.count == 0 then
				append globaltracks.oniondata.LayerIndex 1
			else
			(
				local grpLayer = getLayersInGroup 1
				append globaltracks.oniondata.LayerIndex  (grpLayer.count)		--it's been added to the base group so use it's count
			)
			append globaltracks.oniondata.isAltMaterial false						--add it not in alt material mode
			append globaltracks.oniondata.altMaterial undefined						--add an undefined material.
			append globaltracks.oniondata.isAltProperty  false
			append globaltracks.oniondata.AltProperty "11111110"
			append globaltracks.oniondata.UseAltProperty "00000000"
		),
		function deleteLayer lmRef refresh:true=
		(
			if (PREF_Debug_Mode)  then print ("FN: deleteLayer lmRef: " + lmref.name)
			local name = lmRef.name
			--check and make sure the current layer isn't the active layer...if it is..force it back to world layer
			if lmRef.current = true then
			(
				local L = layermanager.getLayer 0
				L.current = true
			)
			local deleted = LayerManager.deleteLayerByName lmRef.name
			--remove the index from the globaltracks 
			if deleted == true then
			(
				local delLayInd = finditem globaltracks.oniondata.layerName name 
				--get the layers in the grouplayer
				local laysInGrp = getGroupLayersFromLayer delLayInd 
				local layInd = globaltracks.oniondata.LayerIndex[ delLayInd ]
				
				for l in laysInGrp do
					if globaltracks.oniondata.layerIndex[ l ] >= layInd do
						globaltracks.oniondata.layerIndex[ l ] -= 1
				
				deleteitem globaltracks.oniondata.layerName delLayInd 
				deleteitem globaltracks.oniondata.LayerIndex delLayInd
				deleteitem globaltracks.oniondata.LayerGroup delLayInd
				deleteitem globaltracks.oniondata.AltMaterial delLayInd
				deleteitem globaltracks.oniondata.isAltMaterial delLayInd
				deleteitem globaltracks.oniondata.isAltProperty delLayInd
				deleteitem globaltracks.oniondata.AltProperty delLayInd
				
				if refresh then Onion.ui.refresh()
			)
			else print ("Could not delete layer: " + name as string)
			--do a garbage collection just cuz
			gc()
		),
		/*
		function renameLayer =
		(
		),
		*/
		function addObjectsToLayer objectAry maxLayerName =
		(
			if (PREF_Debug_Mode)  then print ("FN: addObjectsToLayer Objectary: " + objectAry as string + " MaxLayerName: " + maxLayerName as string )
			local theLay = layerManager.getLayerFromName maxLayerName 
			
			local successAry =#()
			local failedAry = #()
			--check to see if i'm in alt material mode
			for obj in ObjectAry where obj != undefined do 
			(
				local inAltMode = false
				--sanity check for alternate material.
				if (getappdata obj 1108) != undefined then
				(
					--object is either on a layer with alternate material checked or is from an old version and has left over app data
					local layerInd = finditem globaltracks.oniondata.layername obj.layer.name
					if layerInd > 0 then
					(
						if (globaltracks.oniondata.isAltMaterial[ layerInd ]) then
						(
							--it definatly is in alt material mode 
							append failedAry obj
							--skip this object
							inAltMode = true
						)
					)
				)

				if not inAltMode then
				(
					theLay.addnode obj
					--update settings	
					if ( PREF_Inherit_Wire ) then obj.wirecolor = theLay.wirecolor
					if ( PREF_Inherit_Display ) then
					(
						if isproperty obj #boxmode do obj.boxmode = theLay.boxmode
						if isproperty obj #backfacecull do obj.backfacecull = theLay.backfacecull
						if isproperty obj #alledges do obj.alledges = not theLay.alledges
						if isproperty obj #vertexticks do obj.vertexticks = theLay.vertexticks
						if isproperty obj #showtrajectory do obj.showtrajectory = theLay.showTrajectory
						if isproperty obj #xray do obj.xray = theLay.xray
						if isproperty obj #ignoreExtents do obj.ignoreExtents = theLay.ignoreExtents
						if isproperty obj #showfrozeningray do obj.showfrozeningray = theLay.showfrozeningray 
						if isproperty obj #showvertexcolors do obj.showvertexcolors = theLay.showvertexcolors
						if isproperty obj #vertexcolorsshaded do obj.vertexcolorsshaded = theLay.vertexcolorsshaded 
					)
					if ( PREF_Inherit_Render ) then
					(
						if isproperty obj #visibility do obj.visibility =theLay.visibility 
						if isproperty obj #renderable do obj.renderable =theLay.renderable 
						if isproperty obj #inheritvisibility do obj.inheritvisibility =theLay.inheritvisibility 
						if isproperty obj #primaryvisibility do obj.primaryvisibility =theLay.primaryvisibility 
						if isproperty obj #secondaryvisibility do obj.secondaryvisibility =theLay.secondaryvisibility 
						if isproperty obj #receiveshadows do obj.receiveshadows =theLay.receiveshadows 
						if isproperty obj #castshadows do obj.castshadows =theLay.castshadows 
						if isproperty obj #applyatmospherics do obj.applyatmospherics =theLay.applyatmospherics 
						if isproperty obj #renderoccluded do obj.renderoccluded =theLay.renderoccluded 
					)
					if ( PREF_Inherit_Blur ) then
					(
						if isproperty obj #imagemotionblurmultiplier do obj.imagemotionblurmultiplier =theLay.imagemotionblurmultiplier 
						if isproperty obj #motionbluron do obj.motionbluron =theLay.motionbluron 
						if isproperty obj #motionblur do obj.motionblur =theLay.motionblur 
					)
					append successAry obj
				)

			)
			if theLay.on == false then
			(
				successAry.isHidden = true
				successAry.isSelected = false
			)
			if theLay.lock == true then 
			(
				successAry.isSelected = false
				successAry.isFrozen = true
			)
			if failedAry.count > 0 then
			(
				messageBox ("Some or All of the objects you intended on adding to " + MaxLayerName + " were in Alternate Material Mode.\nThese objects have NOT been added to the layer.\nA list of these objects will be printed in the listener.")  title:"theOnion Warning:"
				print "FAILED OBJECTS"
				print "----------------------------------------------------"
				for i in failedAry do print i.name
				print "----------------------------------------------------"
			)
		),
		function convertLayers2SelectionSets =
		(
			if (PREF_Debug_Mode)  then print ("FN: convertLayers2SelectionSets ")
			for L = 1 to LayerManager.count do
			(
				max select none
				Lay = LayerManager.getLayer (L-1)
				Lay.select true
				selectionsets[ Lay.name ] = selection
			)
		),
		function convertSelectionSets2Layers =
		(
			if (PREF_Debug_Mode)  then print ("FN: convertSelectionSets2Layers")
			disablesceneredraw()
			for S = 1 to SelectionSets.count do
			(
				--make a new one in the max system
				L = LayerManager.NewLayer()
				--add it to the First group--"main"
				L.setName (getNamedSelSetName S)
				Onion.addObjectsToLayer selectionsets[S] L.Name
			)
			enablesceneredraw()
			Onion.ui.refresh()
		), 
		
	

			
		------   core  -------------------------------------------------------------------------------------------------------------------------------
		function cleanLayers =
		(
			if (PREF_Debug_Mode)  then print "FN: cleanLayers()"
			local delarry = #()
			for L = 1 to globaltracks.oniondata.layername.count do
			(
				lmref = layermanager.getLayerfromname globaltracks.oniondata.layername[ L ]
				if lmref == undefined then
				(
					---eeeek. no matching layer was found...remove that layer!
					if (PREF_Debug_Mode)  then print "\tfound wacked layer..deleting it."
					append delarry L
				)	
			)
			if delarry.count > 0 then 
			(
				for L = delarry.count to 1 by -1 do
				(
					--get the layers in the grouplayer
					local laysInGrp = getGroupLayersFromLayer delarry[L]  
					local layInd = globaltracks.oniondata.LayerIndex[ delarry[L] ]
					
					for g in laysInGrp do
						if globaltracks.oniondata.layerIndex[g ] >= layInd do
							globaltracks.oniondata.layerIndex[g ] -= 1
					
					deleteitem globaltracks.oniondata.layerName delarry[L] 
					deleteitem globaltracks.oniondata.LayerIndex delarry[L] 
					deleteitem globaltracks.oniondata.LayerGroup delarry[L] 
					deleteitem globaltracks.oniondata.AltMaterial delarry[L] 
					deleteitem globaltracks.oniondata.isAltMaterial delarry[L] 
				)
			)
			if (finditem globaltracks.oniondata.isAltMaterial true) == 0 then
				globaltracks.oniondata.MaterialHolder = #()
		),
		function aquireMaxLayers =
		(
			if (PREF_Debug_Mode)  then print "FN: aquireMaxLayers()"
			-- scan the scene for new layers
			if LayerManager.count > 1 do
			(
				for LM = 2 to LayerManager.count do
				(
					local Lay = layerManager.getLayer (LM-1)
					--if it doesn't find an existing layer of the same name, build the layer
					if ( finditem globaltracks.oniondata.Layername lay.name ) == 0 then addLayer Lay
				)
			)
		),		
		function setupCallbacks =
		(
			if (PREF_Debug_Mode)  then print "FN: setupCallbacks()"
			callbacks.removeScripts id:#Onion
			callbacks.addScript #systemPreReset		"destroyDialog OnionRoll" 	id:#Onion
			callbacks.addScript #systemPreNew		"destroyDialog OnionRoll; if (custAttributes.getdef globaltracks 1).name == \"OnionData\" then custAttributes.delete globaltracks 1"	id:#Onion
			callbacks.addScript #filePreOpen			"destroyDialog OnionRoll" 	id:#Onion
			callbacks.addScript #filePreMerge		"destroyDialog OnionRoll" 	id:#Onion
		),
		function setupDataStruct =
		(
			if (PREF_Debug_Mode)  then print "FN: setupDataStruct()"
			OnionData = attributes "OnionData"	
			(
				parameters main rollout:blank
				(		
					--version .99 i added the animatable:false tag to these
					OnionVersion type:#float animatable:false
					FloaterPosition type:#Point3 default:[300,300,300] animatable:false
					GroupName type:#StringTab tabSizeVariable:true	animatable:false				--Array of strings.  Each one a group name. #("a","b",c")
					GroupOrder type:#IntTab tabSizeVariable:true animatable:false					--Order that the groups appear in.  ex: #(3,1,2) -> "c" first "a", "b"
					GroupOpen type:#boolTab tabSizeVariable:true default:true animatable:false
					LayerName type:#StringTab tabSizeVariable:true	animatable:false				--Array of strings.  Order 
					LayerGroup type:#IntTab tabSizeVariable:true animatable:false					--Array of ints...what group index the layer is a part of
					LayerIndex type:#IntTab tabSizeVariable:true animatable:false					--
					AltMaterial type:#materialTab tabSizeVariable:true animatable:false				--store each alternate material in the index of the layer
					isAltMaterial type:#boolTab tabSizeVariable:true default:false animatable:false	
					MaterialHolder type:#materialTab tabSizeVariable:true	animatable:false			--store copies of scene materials
					pickedLayer type:#String animatable:false	
					--version 1.00 added below
					UseAltProperty type:#stringTab  tabSizeVariable:true	animatable:false
					AltProperty type:#stringTab  tabSizeVariable:true	animatable:false
					isAltProperty  type:#boolTab tabSizeVariable:true default:false animatable:false	
				)
				rollout blank "blank"
				(
				)
			)
			custAttributes.add globaltracks OnionData 
			
			-- setup add the basics
			globaltracks.oniondata.GroupName[1] = "Main"		--set the first group name
			globaltracks.oniondata.GroupOpen[1] = true
			globaltracks.oniondata.GroupOrder[1] = 1			--set the first group order
			globaltracks.oniondata.OnionVersion =1.10
		),
		function upgradeDataStruct =
		(
			if (PREF_Debug_Mode)  then print "FN: upgradeDataStruct()"
			grpNameTemp =#()
			for i in globaltracks.oniondata.GroupName do append grpNameTemp (i as string)
			 
			grpOrderTemp = #()
			for i in globaltracks.oniondata.GroupOrder do append grpOrderTemp (i as integer)

			layNameTemp = #()
			for i in globaltracks.oniondata.LayerName do append layNameTemp (i as string)
			
			layGrpTemp = #()
			for i in globaltracks.oniondata.LayerGroup do append layGrpTemp (i as integer)
			
			layIndTemp = #()
			for i in globaltracks.oniondata.LayerIndex do append layIndtemp (i as integer)
			
			isAltTemp = #()
			for i in globaltracks.oniondata.isAltmaterial do append isAltTemp i 
			
			AltMatTemp = #()
			for i in globaltracks.oniondata.AltMaterial do append AltMatTemp i
			
			matHoldTemp = #()
			for i in globaltracks.oniondata.MaterialHolder do append matHoldTemp i
			
			isAltPropTemp = #()
			for i in globaltracks.oniondata.isAltProperty do append isAltPropTemp i 
			
			AltPropTemp = #()
			for i in globaltracks.oniondata.AltProperty do append AltPropTemp i
			
			UseAltPropTemp = #()
			for i in globaltracks.oniondata.UseAltProperty do append UseAltPropTemp i

			--delete the CA
			custAttributes.delete globaltracks 1
			if (PREF_Debug_Mode)  then print "FN: init - deleted CA"
			setupDataStruct()
			
			globaltracks.oniondata.GroupOrder = #()
			globaltracks.oniondata.GroupName = #()
			for i in grpNameTemp do
				append globaltracks.oniondata.GroupName i
			for i in grpOrderTemp do
				append globaltracks.oniondata.GroupOrder i
			for i in layNameTemp do
				append globaltracks.oniondata.LayerName i
			for i in layGrpTemp do
				append globaltracks.oniondata.LayerGroup i
			for i in layIndTemp do
				append globaltracks.oniondata.LayerIndex i
			for i in isAltTemp do
				append globaltracks.oniondata.isAltmaterial i
			for i in AltMatTemp do
				append globaltracks.oniondata.AltMaterial i
			for i in matHoldTemp do
				append globaltracks.oniondata.MaterialHolder i
			for i in isAltPropTemp do
				append globaltracks.oniondata.isAltProperty i
			for i in AltPropTemp do
				append globaltracks.oniondata.AltProperty i
			for i in UseAltPropTemp do
				append globaltracks.oniondata.UseAltProperty i

		),
		function checkVersion =
		(
			if (PREF_Debug_Mode)  then print "FN: checkVersion()"
			if not (isProperty globaltracks.oniondata #OnionVersion) then
			(
				--push people up to the new version.
				if (custAttributes.getdef globaltracks 1).name == "OnionData" then 
				(	
			
					--push people up to the new version.
					if (custAttributes.getdef globaltracks 1).name == "OnionData" then 
					(	custAttributes.delete globaltracks 1
						setupDataStruct()
						messageBox "The OnionData in this scene has been updated.  However, the grouping has been lost.\nPlease re-organize your layers and save the file.   Sorry for the inconvience." title:"theOnion Warning:"
					)
					else messageBox "a mysterious force has prevented you from upgrading the onion.  seek help." title:"theOnion Warning:"		
				)
			)
			--version 0.99 removed the animatable tag on the layer properties			
			if globaltracks.oniondata.OnionVersion < 1.0 then
			(
				if (custAttributes.getdef globaltracks 1).name == "OnionData" then 
				(
					upgradeDataStruct()
					for i = 1 to globaltracks.oniondata.layername.count do
					(
						append globaltracks.oniondata.isAltProperty  false
						append globaltracks.oniondata.AltProperty "11111110"
						append globaltracks.oniondata.UseAltProperty "00000000"
					)
					messageBox "Thank you for using the Onion.\nThe OnionData in this scene has been updated to version 1.0.\nAlternate Properties are now possible.\n - Dave H - "	 title:"theOnion Warning:"			
				)
				else messageBox "a mysterious force has prevented you from upgrading the onion.  seek help." title:"theOnion Warning:"
			)
			--version 1.10 added GroupOpen to the data structure..
			if not (isProperty globaltracks.oniondata #GroupOpen) then
			(
				if (custAttributes.getdef globaltracks 1).name == "OnionData" then 
				(
					upgradeDataStruct()
					if (PREF_Debug_Mode)  then print "FN: checkVersion - upgraded to 1.10"
					for i = 1 to globaltracks.oniondata.groupname.count do
					(
						if (PREF_Debug_Mode)  then print "FN: checkVersion - adding group open data"
						append globaltracks.oniondata.groupOpen true
					)
				)
			)
		),
		function kill =
		(
			if (PREF_Debug_Mode)  then print "FN: kill()"
			if (custAttributes.getdef globaltracks 1).name == "OnionData" then custAttributes.delete globaltracks 1
			else
			(			
				globaltracks.oniondata.layername = #()
				globaltracks.oniondata.layerindex = #()
				globaltracks.oniondata.layergroup = #()
				globaltracks.oniondata.groupName = #()
				globaltracks.oniondata.GroupOrder = #()
				globaltracks.oniondata.AltMaterial = #()
				globaltracks.oniondata.isAltMaterial = #()
				globaltracks.oniondata.MaterialHolder = #()
				globaltracks.oniondata.isAltProperty = #()
				globaltracks.oniondata.AltProperty = #()
				globaltracks.oniondata.UseAltProperty = #()
			)
			destroydialog OnionRoll
		),
		function launch =
		(
			if (PREF_Debug_Mode)  then print "FN: launch()"
			--check to see if data exists or check version
			if not (isProperty globaltracks #oniondata) then setupDataStruct()
			checkVersion()
			--gather any layers that it doesn't already have
			aquireMaxLayers()
			--do some cleanup
			cleanLayers()
			--setup callbacks
			setupCallbacks()
			--launch the ui
			ui.showMain()
		),
		function init =
		(
			-- load time function where retrieve onion preferences and set the members
			local INIFile = ( OnionPath + "Onion.ini" )
			
			if (getFiles INIFile).count == 0 then
			(
				--set the settings from the INI
				setINISetting INIFile "UICOLORS" "LayerHideCheckColor" "182,189,255"
				PREF_UI_HideCheckColor = ([182,189,255 ] as color )
					
				setINISetting INIFile "UICOLORS" "ActiveLayerCheckColor" "251.0,196.0,65.0"
				PREF_UI_ActiveLayerCheckColor  = ([ 251.0,196.0,65.0 ] as color )
				
				setINISetting INIFile "UICOLORS" "XRefCheckColor" "255,240,180"
				PREF_UI_XRefCheckColor  = ([ 255,240,180 ] as color )
				
				setINISetting INIFile "OPTIONS" "DisplayXRefScene" "false"
				PREF_DisXRScene = false
				
				setINISetting INIFile "OPTIONS" "InheritWireColor" "false"
				PREF_Inherit_Wire= false 
				
				setINISetting INIFile "OPTIONS" "InheritDisplay" "false"
				PREF_Inherit_Display = false 
				
				setINISetting INIFile "OPTIONS" "InheritRender" "false"
				PREF_Inherit_Render = false
				
				setINISetting INIFile "OPTIONS" "InheritBlur" "false"
				PREF_Inherit_Blur = false 
		
				setINISetting INIFile "OPTIONS" "PromptNameOnNew" "false"
				PREF_PromptOnNew  = false 	
				
				setINISetting INIFile "OPTIONS" "DebugMode" "false"
				PREF_Debug_Mode  = false 
			
			)
			else
			(
				--get the settings from the INI
				local HideCheckColorAry = convertStringAry2IntAry ( getINISetting INIFile "UICOLORS" "LayerHideCheckColor" )
				PREF_UI_HideCheckColor = ([ HideCheckColorAry[1], HideCheckColorAry[2], HideCheckColorAry[3] ] as color )
					
				local ActiveLayerCheckAry = convertStringAry2IntAry ( getINISetting INIFile "UICOLORS" "ActiveLayerCheckColor" )
				PREF_UI_ActiveLayerCheckColor  = ([ ActiveLayerCheckAry[1], ActiveLayerCheckAry[2], ActiveLayerCheckAry[3] ] as color )
				
				local XRefCheckColorAry = convertStringAry2IntAry ( getINISetting INIFile "UICOLORS" "XRefCheckColor" )
				PREF_UI_XRefCheckColor  = ([ XRefCheckColorAry[1], XRefCheckColorAry[2], XRefCheckColorAry[3] ] as color )
				
				PREF_DisXRScene = (getINISetting INIFile "OPTIONS" "DisplayXRefScene")
				if PREF_DisXRScene == "false" then PREF_DisXRScene = false else PREF_DisXRScene = true
				
				PREF_Inherit_Wire = (getINISetting INIFile "OPTIONS" "InheritWireColor")
				if PREF_Inherit_Wire== "false" then PREF_Inherit_Wire= false else PREF_Inherit_Wire= true
				
				PREF_Inherit_Display = (getINISetting INIFile "OPTIONS" "InheritDisplay")
				if PREF_Inherit_Display == "false" then PREF_Inherit_Display = false else PREF_Inherit_Display = true
				
				PREF_Inherit_Render = (getINISetting INIFile "OPTIONS" "InheritRender")
				if PREF_Inherit_Render == "false" then PREF_Inherit_Render = false else PREF_Inherit_Render = true
				
				PREF_Inherit_Blur = (getINISetting INIFile "OPTIONS" "InheritBlur")
				if PREF_Inherit_Blur == "false" then PREF_Inherit_Blur = false else PREF_Inherit_Blur = true
		
				PREF_PromptOnNew  = (getINISetting INIFile "OPTIONS" "PromptNameOnNew")
				if PREF_PromptOnNew == "false" then PREF_PromptOnNew  = false else PREF_PromptOnNew = true		
				
				PREF_Debug_Mode = (getINISetting INIFile "OPTIONS" "DebugMode")
				if PREF_Debug_Mode == "false" then PREF_Debug_Mode  = false else PREF_Debug_Mode = true
			)
		)	
	)
	Onion = OnionStruct()
	Onion.Init()
)
